/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

%{
#include "intab.h"
#include "y.tab.h"
#include <stdio.h>

char serr [100];

static int lineno = 1;
%}

id	[a-zA-Z0-9\_\*]*
ws	[ \t]*

%%

\n			lineno++;
		
{ws}		;
"!".*		;

"function" {
	yylval.integer = FUNCTION;
	return (FUNCTION);
}

"subroutine" {
	yylval.integer = SUBROUTINE;
	return (SUBROUTINE);
}

"compile_time" {
	yylval.integer = COMPILE_TIME;
	return (COMPILE_TIME);
}

"OVER:"			return (OVER);

{id} {
	yylval.str = (char*) malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return (ID);
}

"("			return ('(');
")"			return (')');
"["			return ('[');
"]"			return (']');
","			return (',');
"="			return ('=');

. {
    sprintf (serr, "'%c' ('\\%3o'): illegal character", yytext[0], yytext[0]);
    fprintf (stderr, "%s", serr);
}

%%

yyerror(s)
char *s;
{
    fprintf(stderr, "%s: at or before '%s', line %d\n", s, yytext, lineno);
}
